﻿/*
Macro Name: 01_mercari_date.js
Macro URL: https://teilab.net/imacros_mercari/
Author: teilab（テイくん）
Version: 2.0.5
*/


//=================================================================
// JavaScriptエリア①
//=================================================================
//任意の商品数を取得できるようにする処理
var num = prompt("取得したい商品数を入力してください！\n※新しく出品した順番に取得します\n ");
  if (num == null){
    iimClose();
  }

  else if (num == ""){
    alert("数値は必須事項です！");
    iimClose();
  }

  else if (isNaN(num) || !(num >= 1 && num <= 9999)){
    alert("1～9999までの数値（半角）を入力してください！");
    iimClose();
  }

//Datasources内に「メルカリフォルダ」を作成
var foldername = "メルカリ";
imns.FIO.makeDirectory(imns.Pref.getFilePref('defdatapath').path+"\\"+foldername);


//=================================================================
// iMacrosエリア
//=================================================================
// -------------------------------------------------
// 出品中ページにアクセス【macroAccess】
// -------------------------------------------------
var macroAccess = "CODE:";
macroAccess += "SET !REPLAYSPEED FAST" + "\n";
macroAccess += "URL GOTO=https://www.mercari.com/jp/mypage/listings/listing/" + "\n";
iimPlay(macroAccess);

// -------------------------------------------------
// 出品中商品があるかチェック【macroCheck」
// -------------------------------------------------
var macroCheck = "CODE:";
macroCheck += "SET !REPLAYSPEED FAST" + "\n";
macroCheck += "SET !ERRORIGNORE YES" + "\n";
macroCheck += "SET !TIMEOUT_STEP 1" + "\n";

//商品があるかないかは商品URLで判定 ※重要
macroCheck += "TAG POS={{inLoop}} TYPE=A ATTR=CLASS:mypage-item-link EXTRACT=HREF" + "\n";

// -------------------------------------------------
// 出品中の全データ取得【macro】
// -------------------------------------------------
var macro = "CODE:";
macro += "SET !REPLAYSPEED FAST" + "\n";
macro += "SET !ERRORIGNORE YES" + "\n";

//出品商品の詳細ページ移動
macro += "TAG POS={{inLoop}} TYPE=A ATTR=CLASS:mypage-item-link" + "\n";

////データ吸い出しエリア////
macro += "SET !TIMEOUT_PAGE 2" + "\n"; //遅延対策

//ID
macro += "SET ID EVAL(\"'{{!URLCURRENT}}'.replace(/.*items\\/(.*?)\\//g,'$1');\")" + "\n"; //URLからID以外を除去

//商品名
macro += "TAG POS=1 TYPE=H2 ATTR=CLASS:item-name EXTRACT=TXT" + "\n";
macro += "SET ITEM_NAME {{!EXTRACT}}" + "\n";
macro += "SET !EXTRACT NULL" + "\n"; //EXTRACTに残っているデータを破棄【重要】

//商品説明
macro += "TAG POS=1 TYPE=P ATTR=CLASS:item-description-inner EXTRACT=TXT" + "\n";
macro += "SET DESCRIPTION {{!EXTRACT}}" + "\n";
macro += "SET !EXTRACT NULL" + "\n";

//カテゴリ
macro += "TAG XPATH=/html/body/div[1]/section/div[1]/table/tbody/tr[2]/td/a[1]/div EXTRACT=TXT" + "\n"; //カテゴリ1
macro += "SET TRIMMED EVAL(\"'{{!EXTRACT}}'.replace(/ /g,'');\")" + "\n"; //いらない空白を除去
macro += "SET CATEGORY_1 EVAL(\"var s='{{TRIMMED}}'; var x; if(s!='#EANF#'){ x='{{TRIMMED}}';} x\")" + "\n"; //#EANF#の場合のみ値を空にする
macro += "SET !EXTRACT NULL" + "\n";

macro += "TAG XPATH=/html/body/div[1]/section/div[1]/table/tbody/tr[2]/td/a[2]/div EXTRACT=TXT" + "\n"; //カテゴリ2
macro += "SET TRIMMED EVAL(\"'{{!EXTRACT}}'.replace(/ /g,'');\")" + "\n";
macro += "SET CATEGORY_2 EVAL(\"var s='{{TRIMMED}}'; var x; if(s!='#EANF#'){ x='{{TRIMMED}}';} x\")" + "\n";
macro += "SET !EXTRACT NULL" + "\n";

macro += "TAG XPATH=/html/body/div[1]/section/div[1]/table/tbody/tr[2]/td/a[3]/div EXTRACT=TXT" + "\n"; //カテゴリ3
macro += "SET TRIMMED EVAL(\"'{{!EXTRACT}}'.replace(/ /g,'');\")" + "\n";
macro += "SET CATEGORY_3 EVAL(\"var s='{{TRIMMED}}'; var x; if(s!='#EANF#'){ x='{{TRIMMED}}';} x\")" + "\n";
macro += "SET !EXTRACT NULL" + "\n";

//商品のサイズ
macro += "TAG POS=1 TYPE=TH ATTR=TXT:商品のサイズ" + "\n";
macro += "TAG POS=R1 TYPE=TD ATTR=* EXTRACT=TXT" + "\n";
macro += "SET SIZE EVAL(\"var s='{{!EXTRACT}}'; var x; if(s!='#EANF#'){ x='{{!EXTRACT}}';} x\")" + "\n";
macro += "SET !EXTRACT NULL" + "\n";

//ブランド
macro += "TAG POS=1 TYPE=TH ATTR=TXT:ブランド" + "\n";
macro += "TAG POS=R1 TYPE=TD ATTR=* EXTRACT=TXT" + "\n";
macro += "SET BRAND EVAL(\"'{{!EXTRACT}}'.replace(/ /g,'').replace(/\\s/g,'');\")" + "\n";
macro += "SET !EXTRACT NULL" + "\n";

//商品の状態
macro += "TAG POS=1 TYPE=TH ATTR=TXT:商品の状態" + "\n";
macro += "TAG POS=R1 TYPE=TD ATTR=* EXTRACT=TXT" + "\n";
macro += "SET CONDITION {{!EXTRACT}}" + "\n";
macro += "SET !EXTRACT NULL" + "\n";

//配送料の負担
macro += "TAG POS=1 TYPE=TH ATTR=TXT:配送料の負担" + "\n";
macro += "TAG POS=R1 TYPE=TD ATTR=* EXTRACT=TXT" + "\n";
macro += "SET CARRIAGE {{!EXTRACT}}" + "\n";
macro += "SET !EXTRACT NULL" + "\n";

//配送の方法
macro += "TAG POS=1 TYPE=TH ATTR=TXT:配送の方法" + "\n";
macro += "TAG POS=R1 TYPE=TD ATTR=* EXTRACT=TXT" + "\n";
macro += "SET METHOD {{!EXTRACT}}" + "\n";
macro += "SET !EXTRACT NULL" + "\n";

//配送元地域
macro += "TAG POS=1 TYPE=TH ATTR=TXT:配送元地域" + "\n";
macro += "TAG POS=R1 TYPE=TD ATTR=* EXTRACT=TXT" + "\n";
macro += "SET AREA {{!EXTRACT}}" + "\n";
macro += "SET !EXTRACT NULL" + "\n";

//配送日の目安
macro += "TAG POS=1 TYPE=TH ATTR=TXT:発送日の目安" + "\n";
macro += "TAG POS=R1 TYPE=TD ATTR=* EXTRACT=TXT" + "\n";
macro += "SET DATE {{!EXTRACT}}" + "\n";
macro += "SET !EXTRACT NULL" + "\n";

//価格
macro += "TAG POS=1 TYPE=SPAN ATTR=CLASS:item-price<SP>bold EXTRACT=TXT" + "\n";
macro += "SET PRICE EVAL(\"'{{!EXTRACT}}'.replace(/[\\\\¥￥]/g,'').replace(/,/g,'');\")" + "\n"; //円マークとカンマを除去
macro += "SET !EXTRACT NULL" + "\n";

macro += "SET !TIMEOUT_PAGE 60" + "\n"; //遅延対策（終了）

////CSVファイル書き込みエリア////
macro += "ADD !EXTRACT {{!NOW:yyyy/mm/dd<SP>hh:nn}}" + "\n"; //取得日
macro += "ADD !EXTRACT {{ID}}" + "\n";                       //ID
macro += "ADD !EXTRACT {{!URLCURRENT}}" + "\n";              //URL
macro += "ADD !EXTRACT {{ITEM_NAME}}" + "\n";                //商品名
macro += "ADD !EXTRACT {{DESCRIPTION}}" + "\n";              //商品説明
macro += "ADD !EXTRACT {{CATEGORY_1}}" + "\n";               //カテゴリ1
macro += "ADD !EXTRACT {{CATEGORY_2}}" + "\n";               //カテゴリ2
macro += "ADD !EXTRACT {{CATEGORY_3}}" + "\n";               //カテゴリ3
macro += "ADD !EXTRACT {{SIZE}}" + "\n";                     //サイズ
macro += "ADD !EXTRACT {{BRAND}}" + "\n";                    //ブランド
macro += "ADD !EXTRACT {{CONDITION}}" + "\n";                //商品の状態
macro += "ADD !EXTRACT {{CARRIAGE}}" + "\n";                 //配送料の負担
macro += "ADD !EXTRACT {{METHOD}}" + "\n";                   //配送の方法
macro += "ADD !EXTRACT {{AREA}}" + "\n";                     //配送元地域
macro += "ADD !EXTRACT {{DATE}}" + "\n";                     //配送日の目安
macro += "ADD !EXTRACT {{PRICE}}" + "\n";                    //価格
macro += "ADD !EXTRACT " + "\n";                             //メモ用
macro += "ADD !EXTRACT " + "\n";                             //メモ用
macro += "ADD !EXTRACT " + "\n";                             //メモ用

//全ての抜き出したデータを保存
macro += "SAVEAS TYPE=EXTRACT FOLDER={{!FOLDER_DATASOURCE}}\\メルカリ FILE=01_mercari_date.csv" + "\n";
macro += "WAIT SECONDS=1"+ "\n";

// -------------------------------------------------
// 画像があるかチェック【macroCheck2】
// -------------------------------------------------
var macroCheck2 = "CODE:";
macroCheck2 += "SET !REPLAYSPEED FAST" + "\n";
macroCheck2 += "SET !ERRORIGNORE YES" + "\n";
macroCheck2 += "SET !TIMEOUT_PAGE 1" + "\n"; //遅延対策
macroCheck2 += "TAG POS=1 TYPE=IMG ATTR=SRC:*/photos/*_{{imgLoop}}* EXTRACT=HREF" + "\n";

// -------------------------------------------------
// 商品画像をダウンロード【macroImg】
// -------------------------------------------------
var macroImg = "CODE:";
macroImg += "SET !REPLAYSPEED FAST" + "\n";
macroImg += "ONDOWNLOAD FOLDER={{!FOLDER_DATASOURCE}}\\メルカリ\\img FILE=*" + "\n"; //「imgフォルダ」に変更
macroImg += "TAG POS=1 TYPE=IMG ATTR=SRC:*/photos/*_{{imgLoop}}* CONTENT=EVENT:SAVEITEM" + "\n";

// -------------------------------------------------
// 画像がない場合は商品一覧に戻る【macroBack】
// -------------------------------------------------
var macroBack = "CODE:";
macroBack += "BACK" + "\n";
macroBack += "WAIT SECONDS={{rand}}" + "\n";

// -------------------------------------------------
// 入力された商品数を取得 or 商品がない場合【macroEnd】
// -------------------------------------------------
var macroEnd = "CODE:";
macroEnd += "PROMPT 出品中データを取得しました！<br><br>※データは以下の場所に保存されています。<br>{{!FOLDER_DATASOURCE}}\\メルカリ\\01_mercari_date.csv<SP>" + "\n";
macroEnd += "PROMPT 編集する場合は必ず『Smooth<SP>CSV』を使用してください！<SP><br>※文字コードの関係上『Excel』を使用するとデータが破損します！<SP>" + "\n";

// -------------------------------------------------
// 次のページに移動【macroNext】
// -------------------------------------------------
var macroNext = "CODE:";
macroNext += "SET !REPLAYSPEED FAST" + "\n";
macroNext += "SET !ERRORIGNORE YES" + "\n";
macroNext += "EVENT TYPE=CLICK SELECTOR=HTML>BODY>DIV>MAIN>DIV>UL>LI:nth-of-type(2)>A BUTTON=0" + "\n";
macroNext += "WAIT SECONDS=2"+ "\n";


//=================================================================
// JavaScriptエリア②
//=================================================================
for (var outLoop = 0; outLoop < 200; outLoop++){
  for (var inLoop = 1; ; inLoop++){

    // -------------------------------------------------
    // 出品中商品があるかチェック【macroCheck】
    // -------------------------------------------------
    iimSet("inLoop", inLoop);
    iimPlay(macroCheck);
    var check = iimGetExtract(1); //iimデータはjsで使えないため変数checkに渡す

  　// -------------------------------------------------
　　// 次のページに移動【macroNext】
　　// -------------------------------------------------
    if (inLoop === 51){
      iimPlay(macroNext);
      break; //inLoopを抜ける
    }

    // -------------------------------------------------
    // 入力された商品数を取得 or 商品がない場合【macroEnd】
    // -------------------------------------------------
    else if (outLoop * 50 + inLoop > num || check === "#EANF#"){
      iimPlay(macroEnd);
      iimClose();
    }

    // -------------------------------------------------
    // 出品中の全データ取得【macro】
    // -------------------------------------------------
    else{
      iimSet("inLoop", inLoop);
      iimPlay(macro);

      // -------------------------------------------------
      // 画像があるかチェック【macroCheck2】
      // -------------------------------------------------
      for (var imgLoop = 1; ; imgLoop++){
        iimSet("imgLoop", imgLoop);
        iimPlay(macroCheck2);
        var Check2 = iimGetExtract(1);

        // -------------------------------------------------
        // 画像がない場合は商品一覧に戻る【macroBack】
        // -------------------------------------------------
        if (Check2 === "#EANF#"){
          iimPlay("mercari/setting");  //★【setting.iim（外部ファイル）】を動かす
          var rand = iimGetExtract(1); //★【setting.iim】の上から1番目（MERCARI_DATE_TIME）を取得
          iimSet("rand", rand);
          iimPlay(macroBack);
          break; //imgLoopを抜ける
        }

        // -------------------------------------------------
        // 商品画像をダウンロード【macroImg】
        // -------------------------------------------------
        else {
          iimSet("imgLoop",imgLoop);
          iimPlay(macroImg);
        }
      }
    }
  }
}