﻿/*
Macro Name: 02_price.js
Macro URL: https://teilab.net/imacros_mercari/
Author: teilab（テイくん）
Version: 2.0.5
*/

//=================================================================
// JavaScriptエリア
//=================================================================
//任意の商品数の価格を変更できるようにする処理
var num = prompt("価格を変更したい商品数を入力してください！\n※【01_mercari_date.csv】の上から順番に値下げします\n ");
  if(num == null) {
    iimClose();
  }

  else if(num == "") {
    alert("数値は必須事項です！");
    iimClose();
  }

  else if(isNaN(num) || !(num >=1 && num <=9999)) {
    alert("1～9999までの数値（半角）を入力してください！");
    iimClose();
  }

//「メルカリフォルダ」内に「resultフォルダ」を作成
var foldername = "result";
imns.FIO.makeDirectory(imns.Pref.getFilePref('defdatapath').path+"\\メルカリ\\"+foldername);


//=================================================================
// imacrosエリア
//=================================================================
// -------------------------------------------------
// 商品価格を変更（macro）
// -------------------------------------------------
var macro = "CODE:";
macro += "SET !REPLAYSPEED FAST" + "\n";
macro += "SET !ERRORIGNORE YES" + "\n";

//「01_mercari_date」ファイルをセット
macro += "SET !DATASOURCE {{!FOLDER_DATASOURCE}}\\メルカリ\\01_mercari_date.csv" + "\n";
macro += "SET !DATASOURCE_LINE {{loop}}" + "\n";

//商品詳細ページに行く
macro += "URL GOTO={{!COL3}}" + "\n";

//「商品の編集」をクリック
macro += "TAG POS=1 TYPE=A ATTR=TXT:商品の編集" + "\n";
macro += "WAIT SECONDS=5" + "\n"; //読み込みが遅い場合があるので長めに設定している

//デフォルト価格をBACKキーで削除 ※消し忘れのリスクを考えて1個つづ
//control＋Aを押しながらBACK（KEY=8 MODIFIERS = ctrl,A）でも可能だがミスがたまに起きるので検証の結果↓を採用
macro += "EVENTS TYPE=KEYPRESS SELECTOR=#sell-container>DIV>DIV>FORM>DIV:nth-of-type(5)>DIV>UL>LI>DIV>DIV>DIV>INPUT KEYS=[8]" + "\n"; //BACKキーを押す
macro += "EVENTS TYPE=KEYPRESS SELECTOR=#sell-container>DIV>DIV>FORM>DIV:nth-of-type(5)>DIV>UL>LI>DIV>DIV>DIV>INPUT KEYS=[8]" + "\n";
macro += "EVENTS TYPE=KEYPRESS SELECTOR=#sell-container>DIV>DIV>FORM>DIV:nth-of-type(5)>DIV>UL>LI>DIV>DIV>DIV>INPUT KEYS=[8]" + "\n";
macro += "EVENTS TYPE=KEYPRESS SELECTOR=#sell-container>DIV>DIV>FORM>DIV:nth-of-type(5)>DIV>UL>LI>DIV>DIV>DIV>INPUT KEYS=[8]" + "\n";
macro += "EVENTS TYPE=KEYPRESS SELECTOR=#sell-container>DIV>DIV>FORM>DIV:nth-of-type(5)>DIV>UL>LI>DIV>DIV>DIV>INPUT KEYS=[8]" + "\n";
macro += "EVENTS TYPE=KEYPRESS SELECTOR=#sell-container>DIV>DIV>FORM>DIV:nth-of-type(5)>DIV>UL>LI>DIV>DIV>DIV>INPUT KEYS=[8]" + "\n";
macro += "EVENTS TYPE=KEYPRESS SELECTOR=#sell-container>DIV>DIV>FORM>DIV:nth-of-type(5)>DIV>UL>LI>DIV>DIV>DIV>INPUT KEYS=[8]" + "\n";
macro += "WAIT SECONDS=1" + "\n";

//「価格」を入力
macro += "EVENTS TYPE=KEYPRESS SELECTOR=#sell-container>DIV>DIV>FORM>DIV:nth-of-type(5)>DIV>UL>LI>DIV>DIV>DIV>INPUT CHARS={{!COL16}}" + "\n";
macro += "WAIT SECONDS=1" + "\n";

//「変更をする」をクリック
macro += "TAG POS=1 TYPE=BUTTON FORM=NAME:NoFormName ATTR=TXT:変更する" + "\n";
macro += "WAIT SECONDS=2" + "\n";

//値下げ後の価格を抜き出す
macro += "SET !TIMEOUT_STEP 2" + "\n"; //遅延対策
macro += "TAG POS=1 TYPE=SPAN ATTR=CLASS:item-price<SP>bold EXTRACT=TXT" + "\n";

//値下げが成功したか判定（失敗は☓「#EANF#」、成功は◯）
macro += "SET MARK EVAL(\"var s='{{!EXTRACT}}'; if(s ==='#EANF#'){s = '☓';} else{s = '◯';} \") " + "\n";
macro += "SET !EXTRACT NULL" + "\n"; //EXTRACTに残っているデータを破棄【重要】

////CSVファイルに書き込み////
macro += "ADD !EXTRACT {{!NOW:yyyy/mm/dd<SP>hh:nn}}" + "\n"; //取得日時
macro += "ADD !EXTRACT {{!COL3}} " + "\n";                   //URL
macro += "ADD !EXTRACT {{!COL4}} " + "\n";                   //商品名
macro += "ADD !EXTRACT {{MARK}} " + "\n";                    //判定

//「02_price.csv」に保存
macro += "SAVEAS TYPE=EXTRACT FOLDER={{!FOLDER_DATASOURCE}}\\メルカリ\\result FILE=02_price.csv" + "\n";

macro += "WAIT SECONDS={{rand}}" + "\n"; //★ランダム（ユーザ設定した）待ち時間

// -------------------------------------------------
// 入力した商品数の価格を変更した場合（macroEnd）
// -------------------------------------------------
var macroEnd = "CODE:";
macroEnd += "PROMPT 価格の変更が完了しました。<br><br>※結果は以下の場所に保存されています。<br>{{!FOLDER_DATASOURCE}}\\メルカリ\\result\\02_price.csv<SP>" + "\n";
macroEnd += "URL GOTO=file:{{!FOLDER_DATASOURCE}}\\メルカリ\\result\\02_price.csv" + "\n"; //ファイルを開く


//=================================================================
// JavaScriptエリア
//=================================================================
for (var loop=1; loop<=9999; loop++){

   // -------------------------------------------------
   // 入力した商品数の価格を変更した場合（macroEnd）
   // -------------------------------------------------
   if (loop > num){
     iimPlay(macroEnd);
     iimClose();
   }

   // -------------------------------------------------
   // 商品価格を変更（macro）
   // -------------------------------------------------
   else{
     iimPlay("mercari/setting");  //★【setting.iim（外部ファイル）】を動かす
     var rand = iimGetExtract(2); //★【setting.iim】の上から2番目（PRICE_TIME）を取得
     iimSet("rand", rand);
     iimSet("loop", loop);
     iimPlay(macro);
   }
}
