﻿/*
Macro Name: 03_relist.js
Macro URL: https://teilab.net/imacros_mercari/
Author: teilab（テイくん）
Version: 2.0.5
*/


//=================================================================
// JavaScriptエリア
//=================================================================
//任意の商品数の再出品できるようにする処理
var num = prompt("再出品したい商品数を入力してください\n※『01_db_mercari.csv』の上から順番に出品します。\n ");
    if(num == null) {
      iimClose();
    }

    else if(num == "") {
      alert("数値は必須事項です");
      iimClose();
    }

    else if(isNaN(num) || !(num >=1 && num <=9999)) {
      alert("1～9999までの数値（半角）を入力してください");
      iimClose();
    }

//「メルカリフォルダ」内に「resultフォルダ」を作成
var foldername = "result";
imns.FIO.makeDirectory(imns.Pref.getFilePref('defdatapath').path+"\\メルカリ\\"+foldername);


//=================================================================
// iMacrosエリア
//=================================================================
// -------------------------------------------------
// 出品をする（macro）
// -------------------------------------------------
var macro = "CODE:";
macro += "SET !REPLAYSPEED FAST" + "\n";
macro += "SET !ERRORIGNORE YES" + "\n";

//「01_mercari_date.csv」をセット
macro += "SET !DATASOURCE {{!FOLDER_DATASOURCE}}\\メルカリ\\01_mercari_date.csv" + "\n";
macro += "SET !DATASOURCE_LINE {{loop}}" + "\n";

//TOPページにアクセス
macro += "URL GOTO=https://www.mercari.com/jp/mypage/" + "\n";

//出品マークをクリック
macro += "TAG POS=1 TYPE=I ATTR=CLASS:icon-camera*" + "\n";

//「出品画像」を挿入
macro += "SET IMG_FOLDER {{!FOLDER_DATASOURCE}}\\メルカリ\\img" + "\n"; //長いので「imgフォルダパス」の変数を設定
macro += "SET !TIMEOUT_PAGE 2" + "\n";  //遅延対策
macro += "SET !REPLAYSPEED MEDIUM" + "\n"; //速度調節
macro += "TAG POS=1 TYPE=INPUT:FILE FORM=* ATTR=NAME:* CONTENT={{IMG_FOLDER}}\\{{!COL2}}_1.jpg" + "\n";   //1個目
macro += "TAG POS=1 TYPE=INPUT:FILE FORM=* ATTR=NAME:* CONTENT={{IMG_FOLDER}}\\{{!COL2}}_2.jpg" + "\n";   //2個目
macro += "TAG POS=1 TYPE=INPUT:FILE FORM=* ATTR=NAME:* CONTENT={{IMG_FOLDER}}\\{{!COL2}}_3.jpg" + "\n";   //3個目
macro += "TAG POS=1 TYPE=INPUT:FILE FORM=* ATTR=NAME:* CONTENT={{IMG_FOLDER}}\\{{!COL2}}_4.jpg" + "\n";   //4個目
macro += "TAG POS=1 TYPE=INPUT:FILE FORM=* ATTR=NAME:* CONTENT={{IMG_FOLDER}}\\{{!COL2}}_5.jpg" + "\n";   //5個目
macro += "TAG POS=1 TYPE=INPUT:FILE FORM=* ATTR=NAME:* CONTENT={{IMG_FOLDER}}\\{{!COL2}}_6.jpg" + "\n";   //6個目
macro += "TAG POS=1 TYPE=INPUT:FILE FORM=* ATTR=NAME:* CONTENT={{IMG_FOLDER}}\\{{!COL2}}_7.jpg" + "\n";   //7個目
macro += "TAG POS=1 TYPE=INPUT:FILE FORM=* ATTR=NAME:* CONTENT={{IMG_FOLDER}}\\{{!COL2}}_8.jpg" + "\n";   //8個目
macro += "TAG POS=1 TYPE=INPUT:FILE FORM=* ATTR=NAME:* CONTENT={{IMG_FOLDER}}\\{{!COL2}}_9.jpg" + "\n";   //9個目
macro += "TAG POS=1 TYPE=INPUT:FILE FORM=* ATTR=NAME:* CONTENT={{IMG_FOLDER}}\\{{!COL2}}_10.jpg" + "\n";  //10個目
macro += "TAG POS=1 TYPE=A ATTR=TXT:編集" + "\n";
macro += "TAG POS=1 TYPE=A ATTR=TXT:完了" + "\n";

//「商品名」を入力
macro += "TAG POS=1 TYPE=INPUT:TEXT FORM=ACTION:# ATTR=NAME:name CONTENT={{!COL4}}" + "\n";

//「商品の説明」を入力
macro += "TAG POS=1 TYPE=TEXTAREA FORM=ACTION:# ATTR=NAME:description CONTENT={{!COL5}}" + "\n";

//「カテゴリー」を選択
macro += "TAG POS=1 TYPE=LABEL ATTR=TXT:カテゴリー*" + "\n";
macro += "TAG POS=R1 TYPE=SELECT FORM=* ATTR=NAME:* CONTENT=${{!COL6}}" + "\n";       // カテゴリー1個目
macro += "SET CATEGORY_2 EVAL(\"'{{!COL7}}'.replace(/(.*?)用\\).*/g,'$1用)');\")" + "\n"; // カテゴリー2の「ベビー服とキッズ服」だけ半角空白があるためこの処理がないとエラーが起きる！
macro += "TAG POS=R1 TYPE=SELECT FORM=* ATTR=NAME:* CONTENT=${{CATEGORY_2}}*" + "\n"; // カテゴリー2個目
macro += "TAG POS=R1 TYPE=SELECT FORM=* ATTR=NAME:* CONTENT=${{!COL8}}" + "\n";       // カテゴリー3個目

//「サイズ」を選択
macro += "TAG POS=1 TYPE=LABEL ATTR=TXT:サイズ*" + "\n";
macro += "TAG POS=R1 TYPE=SELECT FORM=* ATTR=NAME:* CONTENT=${{!COL9}}" + "\n";

//「ブランド」を入力
macro += "TAG POS=1 TYPE=LABEL ATTR=TXT:ブランド*" + "\n";
macro += "TAG POS=R1 TYPE=INPUT:TEXT FORM=ACTION:# ATTR=NAME:brandName CONTENT={{!COL10}}" + "\n";

//「商品の状態」を選択
macro += "TAG POS=1 TYPE=LABEL ATTR=TXT:商品の状態*" + "\n";
macro += "TAG POS=R1 TYPE=SELECT FORM=* ATTR=NAME:* CONTENT=${{!COL11}}" + "\n";

//「配送料の負担」を選択
macro += "TAG POS=1 TYPE=LABEL ATTR=TXT:配送料の負担*" + "\n";
macro += "TAG POS=R1 TYPE=SELECT FORM=* ATTR=NAME:* CONTENT=${{!COL12}}" + "\n";

//「配送の方法」を選択
macro += "TAG POS=1 TYPE=LABEL ATTR=TXT:配送の方法*" + "\n";
macro += "TAG POS=R1 TYPE=SELECT FORM=* ATTR=NAME:* CONTENT=${{!COL13}}" + "\n";

//「発送元の地域」を選択
macro += "TAG POS=1 TYPE=LABEL ATTR=TXT:発送元の地域*" + "\n";
macro += "TAG POS=R1 TYPE=SELECT FORM=* ATTR=NAME:* CONTENT=${{!COL14}}" + "\n";

//「発送までの日数」を選択
macro += "TAG POS=1 TYPE=LABEL ATTR=TXT:発送までの日数*" + "\n";
macro += "TAG POS=R1 TYPE=SELECT FORM=* ATTR=NAME:* CONTENT=${{!COL15}}" + "\n";

//「価格」を入力
macro += "TAG POS=1 TYPE=INPUT:NUMBER FORM=ACTION:# ATTR=* CONTENT={{!COL16}}" + "\n";
macro += "SET !REPLAYSPEED FAST" + "\n"; //速度調節終了
macro += "SET !TIMEOUT_PAGE 60" + "\n"; //遅延対策終了

macro += "WAIT SECONDS={{rand}}" + "\n"; //★ランダム（ユーザ設定した）待ち時間

//「出品する」をクリック
macro += "TAG POS=1 TYPE=BUTTON FORM=* ATTR=TXT:出品する " + "\n";
macro += "WAIT SECONDS=3" + "\n"; //読み込みが遅い場合があるので待ち時間必須

//再出品した商品のURL抜き出す
macro += "TAG POS=1 TYPE=A ATTR=HREF:https://www.mercari.com/jp/mypage/items/* EXTRACT=HREF" + "\n";
macro += "SET URL {{!EXTRACT}}" + "\n";
macro += "SET !EXTRACT NULL" + "\n";

//再出品が成功したかURLに「mypage」が含まれているかで判定
macro += "SET TRIMMED EVAL(\"'{{URL}}'.replace(/.*jp\\/(.*?)\\/.*/g,'$1');\")" + "\n"; //「mypage」以外を除去。URLが変化した場合の対策
macro += "SET MARK1 EVAL(\"var s = '{{TRIMMED}}'; if(s === 'mypage'){s = '◯';} else{s = '☓';} \") " + "\n"; //失敗は☓（#EANF#）、成功は◯
macro += "SET !EXTRACT NULL" + "\n";

////JavaScriptに受け渡すデータ取得エリア////
macro += "ADD !EXTRACT {{URL}}" + "\n";                     //再出品した商品URL
macro += "ADD !EXTRACT {{!COL4}}" + "\n";                   //商品名
macro += "ADD !EXTRACT {{MARK1}}" + "\n";                   //判定①（出品）
macro += "WAIT SECONDS=2" + "\n";

// -------------------------------------------------
// 出品できた商品を削除（macroDelete）
// -------------------------------------------------
var macroDelete = "CODE:";
macroDelete += "SET !REPLAYSPEED FAST" + "\n";
macroDelete += "SET !ERRORIGNORE YES" + "\n";

//「01_mercari_date」ファイルをセット
macroDelete += "SET !DATASOURCE {{!FOLDER_DATASOURCE}}\\メルカリ\\01_mercari_date.csv" + "\n";
macroDelete += "SET !DATASOURCE_LINE {{loop}}" + "\n";

//再出品した商品ページに移動
macroDelete += "URL GOTO={{!COL3}}" + "\n";
macroDelete += "TAG POS=1 TYPE=BUTTON ATTR=TXT:この商品を削除する" + "\n";
macroDelete += "WAIT SECONDS=2" + "\n";
macroDelete += "TAG POS=1 TYPE=BUTTON FORM=ACTION:/jp/mypage/items/cancel/* ATTR=TXT:削除する" + "\n";

//削除が成功したか「商品を削除しました」で判定
macroDelete += "TAG POS=1 TYPE=DIV ATTR=TXT:商品を削除しました EXTRACT=TXT" + "\n";
macroDelete += "SET TRIMMED EVAL(\"'{{!EXTRACT}}'.replace(/ /g,'').replace(/\\s/g,'');\")" + "\n"; //いらない空白と改行を除去
macroDelete += "SET MARK2 EVAL(\"var s = '{{TRIMMED}}'; if(s === '商品を削除しました'){s = '◯';} else{s = '☓';} \") " + "\n"; //失敗は☓（#EANF#）、成功は◯
macroDelete += "SET !EXTRACT NULL" + "\n";

////JavaScriptに受け渡すデータ取得エリア////
macroDelete += "ADD !EXTRACT {{MARK2}}" + "\n"; //判定②（削除）

// -------------------------------------------------
// CSVファイルに結果を書き込む（macroCsv）
// -------------------------------------------------
var macroCsv = "CODE:";
macroCsv += "SET !REPLAYSPEED FAST" + "\n";
macroCsv += "SET !ERRORIGNORE YES" + "\n";

//結果を見やすくするための処理
macroCsv += "SET URL EVAL(\"var s = '{{myUrl}}'; var x; if(s !== '#EANF#'){x = '{{myUrl}}';} x\")" + "\n"; //URLがない（#EANF#）場合は空白に変える
macroCsv += "SET MARK2 EVAL(\"var s= '{{myMarkTwo}}'; if(s !== '__undefined__'){s = '{{myMarkTwo}}';} else{s = '☓';} \") " + "\n"; //MARK2がない（__undefined__）場合は✕

////CSVファイル書き込みエリア////
macroCsv += "ADD !EXTRACT {{!NOW:yyyy/mm/dd<SP>hh:nn}}" + "\n"; //取得日
macroCsv += "ADD !EXTRACT {{URL}}" + "\n";                      //再出品した商品URL
macroCsv += "ADD !EXTRACT {{myItem}}" + "\n";                   //商品名
macroCsv += "ADD !EXTRACT {{myMarkOne}}" + "\n";                //判定①（出品）
macroCsv += "ADD !EXTRACT {{MARK2}}" + "\n";                    //判定②（削除）

//「03_result.csv」で保存
macroCsv += "SAVEAS TYPE=EXTRACT FOLDER={{!FOLDER_DATASOURCE}}\\メルカリ\\result FILE=03_relist.csv" + "\n";

// -------------------------------------------------
// //入力した商品数を処理した場合（macroEnd）
// -------------------------------------------------
var macroEnd = "CODE:";
macroEnd += "SET !REPLAYSPEED FAST" + "\n";
macroEnd += "PROMPT 再出品が完了しました。<br><br>※結果は以下の場所に保存されています。<br>{{!FOLDER_DATASOURCE}}\\メルカリ\\result\\03_relist.csv<SP>" + "\n";
macroEnd += "PROMPT 重複しないように再出品した分のデータを削除してください！" + "\n";
macroEnd += "URL GOTO=file:{{!FOLDER_DATASOURCE}}\\メルカリ\\result\\03_relist.csv" + "\n"; //ファイルを開く


//=================================================================
// JavaScriptエリア
//=================================================================
for (var loop=1; loop<=9999; loop++){

  // -------------------------------------------------
  // 出品をする（macro）
  // -------------------------------------------------
  iimPlay("mercari/setting");  //★【setting.iim（外部ファイル）】を動かす
  var rand = iimGetExtract(3); //★【setting.iim】の上から3番目（RELIST_TIME）を取得
  iimSet("rand", rand);
  iimSet("loop", loop);
  iimPlay(macro);
  //jsにデータを受け渡す
  var myUrl = iimGetExtract(1);      //再出品した商品URL
  var myItem = iimGetExtract(2);     //商品名
  var myMarkOne = iimGetExtract(3);  //判定①（出品）
  //iimにデータを受け渡す（jsデータはiimで使用不可のため）【重要】
  iimSet("myUrl", myUrl);
  iimSet("myItem", myItem);
  iimSet("myMarkOne", myMarkOne);

  // -------------------------------------------------
  // 出品できた商品を削除（macroDelete）
  // -------------------------------------------------
  if (myMarkOne === "◯"){
    iimSet("loop", loop); //再度セット
    iimPlay(macroDelete);
    // -------------------------------------------------
    // CSVファイルに結果を書き込む（macroCsv）
    // -------------------------------------------------
    var myMarkTwo = iimGetExtract(1); //判定②（削除）
    iimSet("myMarkTwo", myMarkTwo);
    iimSet("myUrl", myUrl); //再度セット
    iimSet("myItem", myItem); //再度セット
    iimSet("myMarkOne", myMarkOne); //再度セット
    iimPlay(macroCsv);

    // -------------------------------------------------
    // 入力した商品数を処理した場合（macroEnd）
    // -------------------------------------------------
    if (loop + 1 > num){
      iimPlay(macroEnd);
      iimClose();
    }
  }

  // ※ここからは出品できなかった場合の処理
  // -------------------------------------------------
  // CSVファイルに結果を書き込む（macroCsv）
  // 入力した商品数を処理した場合（macroEnd）
  // -------------------------------------------------
  else if (loop + 1 > num){
    iimPlay(macroCsv);
    iimPlay(macroEnd);
    iimClose();
  }

  // -------------------------------------------------
  // CSVファイルに結果を書き込む（macroCsv）
  // -------------------------------------------------
  else {
    iimPlay(macroCsv);
  }
}